// Provide the XMLHttpRequest class for IE 5.x-6.x:
// RESOURCE = http://en.wikipedia.org/wiki/XMLHttpRequest
if( typeof XMLHttpRequest == "undefined" ) XMLHttpRequest = function() {
  try { return new ActiveXObject("Msxml2.XMLHTTP.6.0") } catch(e) {}
  try { return new ActiveXObject("Msxml2.XMLHTTP.3.0") } catch(e) {}
  try { return new ActiveXObject("Msxml2.XMLHTTP") } catch(e) {}
  try { return new ActiveXObject("Microsoft.XMLHTTP") } catch(e) {}
  throw new Error( "This browser does not support XMLHttpRequest." )
};


/*
More information from http://www.w3.org/TR/XMLHttpRequest/
*/
function openurl(node, url){
    function handler() {
        if(this.readyState == 4 && this.status == 200) {
            if( this.responseXML != null && this.responseXML.getElementById('linkMethod').firstChild.data) {
                var linkMethod = this.responseXML.getElementById('linkMethod').firstChild.data;
                var generatedUrl = this.responseXML.getElementById('generatedUrl').firstChild.data;

                var linkNode = document.createElement("a");
                linkNode.setAttribute("href", generatedUrl);
                linkNode.appendChild(document.createTextNode(linkMethod));

                node.appendChild(linkNode);
            }
        }
    }

    var client = new XMLHttpRequest();
    client.onreadystatechange = handler;
    try {
        client.open("GET", url, true);
        client.send(null);
    } catch(e) {
//         Caught exception
        node.appendChild(document.createTextNode(e));
    }

};

function getElementsByClass(node,searchClass,tag) {
    var classElements = new Array();
    var els = node.getElementsByTagName(tag); // use "*" for all elements
    var elsLen = els.length;
    var i, j;
    for (i = 0, j = 0; i < elsLen; i++) {
         if (els[i].className == searchClass) {
             classElements[j] = els[i];
             j++;
         }
    }
    return classElements;
}

function handleOpenUrl() {
    var nodes = getElementsByClass(document, "openUrlAnchor", "p");
    for (var i = 0; i < nodes.length; i++) {
        handleOpenUrlForNode(nodes[i]);
    }
}

function handleOpenUrlForNode(aNode) {
    if (aNode.childNodes.length > 0) {
        var url = aNode.childNodes[0].nodeValue
        aNode.removeChild(aNode.childNodes[0]);

        openurl(aNode, url);
    }
}